# -*- coding: utf-8 -*-
"""
Created on Sun Oct 16 23:03:41 2016

@author: felix
"""

def frattale_cubica(xmin=-3.0,xmax=3.0,ymin=-3.0,ymax=3.0):
    """
    Determina le regioni di stabilita' 
    nel piano complesso
    del metodo di Newton applicato alla 
    funzione cubica f(z)=z**3-1
    
    N.B. Prima di eseguire la function, ricordarsi di caricare 
         in memoria le funzioni  newton.py e cubica.py. 
         Inoltre ricordarsi di importare i pacchetti numpy e pylab.

   Commenti: per ottenere il primo grafico, dalla console lanciare

             >>> frattale_cubica()

             In seguito, fare uno zoom su un particolare del frattale 
             e acquisire i nuovi assi mediante il comando axis, 
             ad esempio

             >>> w=axis()

             la variabile w è formalmente una lista di 4 elementi: 
             con riferimento alla figura, i primi due rappresentano 
             i valori minimo e massimo dell'ascissa e gli ultimi due 
             i valori minimo e massimo dell'ordinata. 
             Quindi è possibile rieseguire la funzione passando 
             questi nuovi valori, al fine di ottenere 
             un'immagine dettagliata della nuova regione selezionata:

             >>> frattale_cubica(w[1],w[2],w[3],w[4])
             
             Si può poi ripetere questa operazione per scoprire nuovi 
             dettagli e verificare così la proprietà di autosimilarità 

    """
    res_x=1200 #num. di pixel sull'asse x
    res_y=1200 #num. di pixel sull'asse y
    zero=[1,-1/2+sqrt(3)/2j,-1/2-sqrt(3)/2j]
    x=linspace(xmin,xmax,res_x)
    y=linspace(ymin,ymax,res_y)
    Z=zeros(shape=(res_x,res_y))
    for i in range(0,res_x):
        if mod(i,100)==0: print(i)
        for j in range(0,res_y):
            [alpha,it]=newton(cubica,complex(x[i],y[j]),1e-4,1000)
            if abs(alpha-zero[0])<1e-2:
                Z[i,j]=0
            elif abs(alpha-zero[1])<1e-2:
                Z[i,j]=0.5
            elif abs(alpha-zero[2])<1e-2:
                Z[i,j]=1
            else:
                Z[i,j]=NaN
    figure(1)
    clf()
    imshow(transpose(Z), cmap = plt.cm.jet, interpolation = 'nearest', extent = (xmin, xmax, ymin, ymax))
    #plot(real(zero),imag(zero),'o')    
    xlabel("Re(c)")
    ylabel("Im(c)")
    show()
    return Z

            